package be.iminds.ilabt.jfed.experiment.setup.config;

import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonProperty;

import javax.annotation.Nonnull;
import javax.annotation.Nullable;

@JsonInclude(JsonInclude.Include.NON_DEFAULT)
@JsonIgnoreProperties(value={"@context"})
public class ProvidedUrlRequestRSpec extends ProvidedRequestRSpec {
    public ProvidedUrlRequestRSpec() {
        super(RequestRSpecSource.PROVIDE_URL,
                null,
                false,
                null,
                false,
                false);
    }

    @JsonCreator
    public ProvidedUrlRequestRSpec(@Nonnull @JsonProperty("source") RequestRSpecSource source,
                                   @Nullable @JsonProperty("providedContentSource") String providedContentSource,
                                   @Nullable @JsonProperty("bindTestedServerToUnboundNodes") Boolean bindTestedServerToUnboundNodes,
                                   @Nullable @JsonProperty("bindUnboundNodesUrn") String bindUnboundNodesUrn,
                                   @Nullable @JsonProperty("autoAssignSpecificNodesUsingListResources") Boolean autoAssignSpecificNodesUsingListResources,
                                   @Nullable @JsonProperty("useNitosLease") Boolean useNitosLease) {
        super(source, providedContentSource, bindTestedServerToUnboundNodes, bindUnboundNodesUrn,
                autoAssignSpecificNodesUsingListResources, useNitosLease);
        assert source == RequestRSpecSource.PROVIDE_URL;
        assert this.getSource() == RequestRSpecSource.PROVIDE_URL;
    }
}
